<template>
    <div class="content">
        <div class="row">
            <section class="col-lg-12 connectedSortable ui-sortable">
                <div class="box box-danger">
                    <div class="box-header with-border">
                        <h3 class="box-title">Latest Members</h3>

                        <div class="box-tools pull-right">
                            <span class="label label-danger">{{ChatStore.userList.length}} Members</span>
                            <button type="button" class="btn btn-box-tool" data-widget="collapse"><i
                                    class="fa fa-minus"></i>
                            </button>
                            <button type="button" class="btn btn-box-tool" data-widget="remove"><i
                                    class="fa fa-times"></i>
                            </button>
                        </div>
                    </div>
                    <div class="box-body no-padding">
                        <ul class="users-list clearfix">
                            <li class="newWidth" v-for="user in ChatStore.userList" @click="changeChatUser(user)">
                                <img src="../../../static/theme/dist/img/user1-128x128.jpg" alt="User Image"
                                     :class="(ChatStore.currentChatUser
                                     && user.id == ChatStore.currentChatUser.id) ? 'current-chat-user' : 'normal-user'">
                                <a class="users-list-name" href="#">{{user.name}}</a>
                                <span class="users-list-date">Today</span>
                            </li>
                        </ul>
                    </div>
                    <div class="box-footer text-center">
                        <a href="javascript:void(0)" class="uppercase">View All Users</a>
                    </div>
                </div>
                <div class="box box-success" style="position: relative; left: 0px; top: 0px;">
                    <div class="box-header ui-sortable-handle" style="cursor: move;">
                        <i class="fa fa-comments-o"></i>

                        <h3 class="box-title">Chat</h3>

                        <div class="box-tools pull-right" data-toggle="tooltip" title="" data-original-title="Status">
                            <div class="btn-group" data-toggle="btn-toggle">
                                <button type="button" class="btn btn-default btn-sm active"><i
                                        class="fa fa-square text-green"></i>
                                </button>
                                <button type="button" class="btn btn-default btn-sm"><i
                                        class="fa fa-square text-red"></i></button>
                            </div>
                        </div>
                    </div>
                    <div class="slimScrollDiv newHeight"
                         style="overflow-x: hidden;position: relative;/* overflow: hidden; */width: auto;overflow-y: auto;">
                        <div class="box-body chat newHeight" id="chat-box" style="overflow: visible; width: auto;">
                            <div class="item" v-for="chat in ChatStore.conversation">
                                <img src="../../../static/theme/dist/img/user2-160x160.jpg" alt="user image"
                                     class="offline">

                                <p class="message">
                                    <a href="#" class="name">
                                        <small class="text-muted pull-right"><i class="fa fa-clock-o"></i> {{chat.created_at}}</small>
                                        {{chat.sender.name}}
                                    </a>
                                    {{chat.content}}
                                </p>
                            </div>
                            <!-- /.item -->
                        </div>
                        <div class="slimScrollBar"
                             style="background: rgb(0, 0, 0); width: 7px; position: absolute; top: 0px; opacity: 0.4; display: none; border-radius: 7px; z-index: 99; right: 1px; height: 224.82px;"></div>
                        <div class="slimScrollRail"
                             style="width: 7px; height: 100%; position: absolute; top: 0px; display: none; border-radius: 7px; background: rgb(51, 51, 51); opacity: 0.2; z-index: 90; right: 1px;"></div>
                    </div>
                    <!-- /.chat -->
                    <div class="box-footer">
                        <div class="input-group">
                            <input class="form-control" placeholder="Type message..." v-model="message">

                            <div class="input-group-btn">
                                <button @click="handleAddChat" type="button" class="btn btn-success">
                                    <i class="fa fa-plus"></i>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
        </div>
    </div>
</template>

<script>
    import {mapState} from 'vuex'

    export default {
        data() {
            return {
                message: null
            }
        },
        created() {
            this.$store.dispatch('setUserList');
        },
        computed: {
            ...mapState({
                UserStore: state => state.UserStore,
                ChatStore: state => state.ChatStore
            })
        },
        methods: {
            changeChatUser(user) {
                this.$store.dispatch('setConversation', user)
            },
            handleAddChat() {
                let _this = this
                if (this.message) {
                    let postData = {
                        'receiver_id': this.ChatStore.currentChatUser.id,
                        'content': this.message,
                    }

                    this.$store.dispatch('addNewChatToConversation', postData)
                        .then(response => {
                            _this.message = null
                        })
                }
            }
        }
    }
</script>
<style scoped>
    .newHeight {
        height: 650px !important;
    }

    .newWidth {
        width: 7% !important;
    }
    .current-chat-user {
        border-radius: 50% !important;
        border: 2px solid #00a65a;
    }
    .normal-user {
        border-radius: 0% !important;
    }
</style>